<?php  
/**
  * Revocació de certificats.
  *
  * Cal estar autenticat com a administrador. Revoca certificats i mostra el resultat per pantalla.
 *
  * @author Eugeni Queralt
  * @package tfcUOC
  */
 require_once ('../page.php');
 session_start();
/**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class ResRevPage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)
 
  }
  // Primer cal estar autenticat per accedir a aquesta zona
 
    $revres = new ResRevPage();

    if (isset($_SESSION['administrador'])) {
        //$signreq -> content = "Estàs autenticat com administrador"."<br>".
        //"Variable de sessió establerta.";
        //Connectar amb la BD
        $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
        if (mysqli_connect_errno ()){
              $revres -> content ="Error de connexió amb la Base de Dades";
        }else {

            $revres -> content ="<form method='post' action=''>
                    <fieldset>
                    <legend>Certificats Revocats</legend>
                    <p>"
                        ."Resultats de la revocació
                    </p>
                    <table>
                    <colgroup><col width='180px'></colgroup>";
            //Recorrem els certificats seleccionats per revocar
            $id = 0;
            while ($id < $_POST['count']){
                if (isset($_POST["checkbox"][$id])) {
                    $ident = $_POST["checkbox"][$id];
                    //Ara seleccionem de la BD la que te l'identificador $ident seleccionat
                    $query = "select * from certificats_clients where crt_id = $ident";
                    $results = $db->query($query);
                    While ($row = $results->fetch_array(MYSQLI_BOTH)){
                        //Posem el certificat a un arxiu
                        file_put_contents('/tmp/cert.pem', $row['certpem']);
                        //Ara revoquem el certificat
                        $passca = "123456";
                        exec ("sudo openssl ca -revoke /tmp/cert.pem -passin pass:$passca -config /etc/ssl/openssl.cnf 2>&1", $revs, $retorna);
                        unset($revs);
                        //Dades del certificat que mostrarem
                        $nom = $row['commonName'];
                        $org = $row['organizationName'];
                        $mailAdr = $row['emailAddress'];

                        //Si $retorna = 1 aleshores s'ha produït error al executar openssl
                        if ($retorna) {
                            $revres -> content .= "<tr><th> <img src='/tfc/imatges/unchecked.gif' /> </th>".
                                    "<td>".$nom."</td>".
                                    "<td>".$org."</td>".
                                    "<td>".$mailAdr."</td>".
                                    "<th>"." Ha fallat la revocació"."</th>".
                                    "</tr>";
                        }else {
                            //Si tot ha anat bé, actualitzem la BD de certificats
                            $motiu = "Revocat per administrador de la CA";                           
                            $query = "update certificats_clients set revocat = 1, motiurev = '$motiu' where crt_id = $ident";
                            $result = $db->query($query);
                            $revres -> content .= "<tr><th> <img src='/tfc/imatges/checked.gif' /> </th>".
                                    "<td>".$nom."</td>".
                                    "<td>".$org."</td>".
                                    "<td>".$mailAdr."</td>".
                                    "<th>"." Revocat"."</th>".
                                    "</tr>";
                        }
                    }
                }
                $id++;
            }
            $revres -> content .= "</table>
                    </fieldset>
                    </form>";
        }
        mysqli_close();
        
      }else {
         $revres -> content = "Error d'autenticació";
      }
    $revres -> Display();
?>