<?php
/**
  * Signatura de peticions.
 *
  * Cal estar autenticat com a administrador.
  * Recull la sel·lecció de les peticions que es volen signar i mostra el resultat per pantalla
  * @author Eugeni Queralt
  * @package tfcUOC
  */

 require_once ('../page.php');
 session_start();
/**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class ResSingPage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)
 
  }
  // Primer cal estar autenticat per accedir a aquesta zona
  // La idea seria mostrar una llista de selecció a l'usuari administrador amb les peticions de signatur pendents
  // Per això cal emmagatzemar l'estat de les peticions a la BD.
  // S'ha d'indicar si estan pendents i si s'ha rebut la confirmació per mail (podria ser una altre mètode...)
  // Fet això l'administrador seleccionarà les que consideri que ha de signar i ho farà.

    $signres = new ResSingPage();

    if (isset($_SESSION['administrador'])) {
        //$signreq -> content = "Estàs autenticat com administrador"."<br>".
        //"Variable de sessió establerta.";
        //Connectar amb la BD
        $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
        if (mysqli_connect_errno ()){
              $signres -> content ="Error de connexió amb la Base de Dades";
        }else {

            //$signres -> content ="Connexió amb la Base de Dades";
            //AQUÍ el codi  de signar0.php!!!!
            $signres -> content ="<form method='post' action=''>
                    <fieldset>
                    <legend>Peticions signades</legend>
                    <p>"
                        ."Resultats de la signatura
                    </p>
                    <table>
                    <colgroup><col width='180px'></colgroup>";
            $id = 0;
            while ($id < $_POST['count']){
                if (isset($_POST["checkbox"][$id])) {
                    //Aquí hauríen de cridar a una funció signar (paràmetre $id)
                    //El següent és una prova
                    //echo $_POST["checkbox"][$id]."<br>";
                    $ident = $_POST["checkbox"][$id];
                    //Ara seleccionem de la BD la que te l'identificador $ident seleccionat
                    $query = "select * from peticions_csr where csr_id = $ident";
                    $results = $db->query($query);
                    While ($row = $results->fetch_array(MYSQLI_BOTH)){
                        //Posem la petició a un arxiu
                        //Obrim per escriptura
                        if (!($Descriptor = fopen("/tmp/peticio.csr","w+"))) {
                            die("No es pot crear el fitxer");
                        }
                        //Posem la petició de la BD a l'arxiu
                        fwrite($Descriptor, $row['pkcs10']);
                        //Tanquem el fitxer
                        fclose($Descriptor);
                        //Ara signem la petició
                        $passca = "123456";
                        exec ("sudo openssl ca -in /tmp/peticio.csr -batch -passin pass:$passca -config /etc/ssl/openssl.cnf -policy policy_anything -out /tmp/cert.pem -notext 2>&1", $revs, $retorna);
                        unset($revs);
                        //Dades de la petició seran exportades a la BD de certificats
                        $resum = $row['csr_descripc'];
                        $data_actual = date("Y-m-d H:m:s");
                        $contrasenyaX = $row['passwd'];
                        $nom = $row['commonName'];
                        $org = $row['organizationName'];
                        $dept = $row['organizationalUnitName'];
                        $mailAdr = $row['emailAddress'];
                        $pais = $row['countryName'];
                        $prov = $row['stateOrProvinceName'];
                        $loc = $row['localityName'];
                        //Si $retorna = 1 aleshores s'ha produït error al executar openssl
                        if ($retorna) {
                            $signres -> content .= "<tr><th> <img src='/tfc/imatges/unchecked.gif' /> </th>".
                                    "<td>".$nom."</td>".
                                    "<td>".$org."</td>".
                                    "<td>".$mailAdr."</td>".
                                    "<th>"."Ha fallat"."</th>".
                                    "</tr>";
                        }else {
                            //Si tot ha anat bé, actualitzem la BD de certificats
                            //Passarem el certifcat (arxiu) a la variable $certpem i a la BD
                            $certpem = file_get_contents('/tmp/cert.pem');
                            //Actualitzem BD de certificats
                            $accents = $db->query("SET NAMES 'utf8'");
                            $query = "insert into certificats_clients values
                              (null,'".$resum."','".$data_actual."','".$contrasenyaX."','".$nom.
                              "','".$org."','".$dept."','".$mailAdr."','".$pais."','".$prov."','".$loc."',0,0,null,'".$certpem."')";
                            $result = $db->query($query);
                            
                            $signres -> content .= "<tr><th> <img src='/tfc/imatges/checked.gif' /> </th>".
                                    "<td>".$nom."</td>".
                                    "<td>".$org."</td>".
                                    "<td>".$mailAdr."</td>".
                                    "</tr>";

                            $query = "update peticions_csr set signada = 1 where csr_id = $ident";
                            $result = $db->query($query);                            
                        }
                    }
                }
                $id++;
            }
            $signres -> content .= "</table>
                    </fieldset>
                    </form>";
        }
        mysqli_close();
        
      }else {
         $signres -> content = "Error d'autenticació";
      }
    $signres -> Display();
?>