<?php  
/**
  * Seleció dels certificats a revocar.
 *
  * Cal estar autenticat com a administrador.
  * Mostra els certificats signats selecciona els que es volen revocar. També mostra si s'ha solicitat per
  * part del client la revocació del seu certificat i el motiu.
  * @author Eugeni Queralt
  * @package tfcUOC
  */

 require_once ('../page.php');
 session_start();
/**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class RevPage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)
 
  }
  // Aquí es revoquen els certificats

    $revp = new RevPage();


    if (isset($_SESSION['administrador'])) {
        //Connectar amb la BD
        $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
        if (mysqli_connect_errno ()){
              $revp -> content ="Error de connexió amb la Base de Dades".mysqli_connect_errno ();
        }else {
                //Recollim els accents
                $accents = $db->query("SET NAMES 'utf8'");
                $query = "select * from certificats_clients where revocat = 0 ";
                $results = $db->query($query);
                $count = $results->num_rows;
                if ($results) {
                    $revp -> content ="<form method='post' action='resultrevocar.php'>
                    <fieldset>
                    <legend>Certificats no revocats</legend>
                    <p>"
                        ."Hi ha ".$count." certificats no revocats. Seleccionar els que es vulguin revocar.
                    </p>
                    <table>
                        <colgroup><col width='180px'></colgroup>";

                    While ($row = $results->fetch_array(MYSQLI_BOTH)){
                        $revp -> content .= "<tr><th> <input type='checkbox' name='checkbox[]' value =".$row['crt_id']." > </th>".
                        "<td>".$row['commonName']."</td>".
                        "<td>".$row['organizationName']."</td>".
                        "<td>".$row['emailAddress']."</td>";
                        if ($row['solrev']==1){
                            $revp -> content .= "<td>Solicitada</td>".
                        "<td><b>Motiu: </b>".$row['motiurev']."</td>";
                        }
                        $revp -> content .="</tr>";
                    }
                    $revp -> content .= "</table>
                    <table>
                            <tr><td ><input type='submit' name='revocar' value='Revocar Certificats'></td></tr>
                    </table>
                    </fieldset>
                    <input type='hidden' name='count' value=$count>
                    </form>";
                }
              }
              mysqli_close();
    } else {
        $revp -> content = "Error d'autenticació";
    }
    $revp ->Display();
?>
