<?php
/**
  * Seleció deles peticions a signar.
 *
 * Cal estar autenticat com a administrador. La idea seria mostrar una llista de selecció a l'usuari administrador amb les peticions de signatur pendents
  * Per això cal emmagatzemar l'estat de les peticions a la BD.S'ha d'indicar si estan pendents i si s'ha rebut la confirmació per mail (podria ser una altre mètode...)
  * Fet això l'administrador seleccionarà les que consideri que ha de signar i ho farà.
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */

 require_once ('../page.php');
 session_start();
 /**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class SingPage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)
 
  }
  // Primer cal estar autenticat per accedir a aquesta zona
  //

    $signreq = new SingPage();

    if (isset($_SESSION['administrador'])) {
        //Connectar amb la BD
        $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
        if (mysqli_connect_errno ()){
              $signreq -> content ="Error de connexió amb la Base de Dades";
        }else {
                //Fem una petició per recollir els accents correctament
                $accents = $db->query("SET NAMES 'utf8'");
                $query = "select * from peticions_csr where signada = 0";
                $results = $db->query($query);
                $count = $results->num_rows;

                if ($results) {
                    $signreq -> content ="<form method='post' action='resultsignar.php'>
                    <fieldset>
                    <legend>Peticions pendents de signar</legend>
                    <p>"
                        ."Hi ha ".$count." peticions pendents. Seleccionar les que es puguin signar.
                    </p>
                    <table>
                        <colgroup><col width='180px'></colgroup>";
                    
                    While ($row = $results->fetch_array(MYSQLI_BOTH)){
                        $signreq -> content .= "<tr><th> <input type='checkbox' name='checkbox[]' value =".$row['csr_id']." > </th>".
                        "<td>".$row['commonName']."</td>".
                        "<td>".$row['organizationName']."</td>".
                        "<td>".$row['emailAddress']."</td>".
                        "</tr>";
                    }
                    $signreq -> content .= "</table>
                    <table>
                            <tr><td ><input type='submit' name='signar' value='Signar Peticions'></td></tr>
                    </table>
                    </fieldset>
                    <input type='hidden' name='count' value=$count>
                    </form>";
                }
             
              }
              mysqli_close();
      }else {
         $signreq -> content = "Error d'autenticació";
      }
    $signreq ->Display();
?>