<?php
/**
  * Recull les dades
  *
  * Recull les dades de la petició PKCS#10 introduïda i tramita la petició
  * de signatura a la CA, actulitzant la BD de peticions.
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */
 require_once ('../page.php');
 session_start(); //control de la sessió de l'usuari
  /**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class ReqPage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)
    
  }

  $req = new ReqPage();
  if (isset($_SESSION['usuari'])) {

          //recollim dades
          $secret_calc = $_POST['secretc'];
          $secret_intr = $_POST['secret'];

          $pwd    = $_POST['pwd'];
          $nom    = $_POST['nom'];
          $org    = $_POST['org'];
          $pais   = $_POST['pais'];
          $prov   = $_POST['prov'];
          $loc    = $_POST['loc'];
          $dept   = $_POST['dept'];
          $mailAdr = $_POST['mailAdr'];
          $pkcs10 = $_POST['pkcs10'];

          $mostrarDades = $nom."<br>".$org."<br>".$pais."<br>".$prov."<br>".$loc."<br>".$dept."<br>".$mailAdr;

          if ($secret_calc == $secret_intr){

              //Creem un resum amb el correu de l'usuari i la contrasenya, pel tal d'anomenar la petició de signatura.
              //Per tal d'evitar que es repeteixi el nom de l'arxiu.
              //Aquest resum el desarem a la BD al camp descripció
              $resum = md5($pwd.$mailAdr);

              //Xifrarem la contrasenya del usuari pert emmagatzemar-la  a la BD;
              $contrasenyaX = sha1($pwd);

              //Data actual
              $data_acual = date("Y-m-d H:m:s");

              //Afegim la informació a a la BD
              $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
              if (mysqli_connect_errno ()){
                    $req -> content ="Error de connexió amb la Base de Dades";
              } 
                else {
                    //Comprovem si existeix la petició del client
                    $query = " select * from peticions_csr where commonName ='$nom'";
                    $results = $db->query($query);
                    if($results->fetch_array(MYSQLI_BOTH)){
                       // Si el Nom (commonName) està present a la BD no es podrà fer la tramitació
                        $req -> content = "Existeix una amb el mateix nom introduït seleccionat. <br>
                        seleccioneu un altre nom diferent al generar la petició";
                    } else {
                        $clau="";    //Aquesta està en poder del client
                        $accents = $db->query("SET NAMES 'utf8'");
                        $query = "insert into peticions_csr values
                          (null,'".$resum."','".$data_acual."','".$contrasenyaX."','".$nom.
                          "','".$org."','".$dept."','".$mailAdr."','".$pais."','".$prov."','".$loc."',0,'".$pkcs10."','".$clau."')";

                        $result = $db->query($query);
                        if ($result) {
                          $req -> content ="La petició  ha estat formulada i pendent de tramitació: ".
                              "<br><br>".$mostrarDades.
                              "<br><br>".$data_acual."<br>";
                              "<br>Has sortit de la sessió s'usuari<br>";
                        }
                    }
                    
              }
              //Tancar BD
              mysqli_close();

          } else  {
              $req -> content ="El secret enviat no es correspon amb l'introduït";
          }
  } else {
        $req -> content = "Error d'autenticació";
  }
  //Aquí el display
  $req ->Display();
  //unset($_SESSION['usuari']); //Sortim sessió d'usuari per evitar duplicitats en les entrades a la bd
  ?>