<?php
/**
  * Recull les dades introduïdes
  *
  * Recull les dades introduïdes per l'usuari i genera i tramita la petició
  * de signatura a la CA, actulitzant la BD de peticions.
  * Nota: La clau privada provisionalment desada, tindrà una profunditat
  * de 512 bit (per defecte)
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */
 require_once ('../page.php');
 session_start(); //control de la sessió de l'usuari
 /**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class ReqPage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)
    
  }

  $req = new ReqPage();
    if (isset($_SESSION['usuari'])) {
          $secret_calc = $_POST['secretc'];
          $secret_intr = $_POST['secret'];

          $pwd    = $_POST['pwd'];
          $usuari = $_POST['usuari'];
          $org    = $_POST['org'];
          $pais   = $_POST['pais'];
          $prov   = $_POST['prov'];
          $loc    = $_POST['loc'];
          $dept   = $_POST['dept'];
          $correu = $_POST['correu'];

          $mostrarDades = $usuari."<br>".$org."<br>".$pais."<br>".$prov."<br>".$loc."<br>".$dept."<br>".$correu;

          if ($secret_calc == $secret_intr){

              //Creem un resum amb el correu de l'usuari i la contrasenya, pel tal d'anomenar la petició de signatura.
              //Per tal d'evitar que es repeteixi el nom de l'arxiu.
              //Aquest resum el desarem a la BD al camp descripció
              $resum = md5($pwd.$correu);

              //Xifrarem la contrasenya del usuari pert emmagatzemar-la  a la BD;
              $contrasenyaX = sha1($pwd);

              //Data actual
              $data_acual = date("Y-m-d H:m:s");

              //Creem la clau privada de l'usuari i la xifrem amb la contrasenya
              exec ("sudo openssl genrsa -des3 -passout pass:$pwd -out /tmp/key.pem  2>&1", $revs);
              unset($revs);
              $pkey = file_get_contents('/tmp/key.pem'); //hem de posar aquí la clau priv en PEM

              //Creem la petició de certificat amb les dades del formulari
              exec ("sudo openssl req -new -key /tmp/key.pem -passin pass:$pwd -subj '/CN=$usuari/O=$org/OU=$dept/C=$pais/ST=$prov/L=$loc/emailAddress=$correu' -out /tmp/req.pem 2>&1", $revs);
              unset($revs);
              $pkcs10 = file_get_contents('/tmp/req.pem'); //hem de posar aquí la petició en PEM

              //Afegim la informació a a la BD
              $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
              if (mysqli_connect_errno ()){
                  $req -> content ="Error de connexió amb la Base de Dades";
              } else {
                  //Comprovem si existeix la petició del client
                  $query = " select * from peticions_csr where commonName ='$usuari'";
                  $results = $db->query($query);
                  if($results->fetch_array(MYSQLI_BOTH)){
                  // Si el Nom (commonName) està present a la BD no es podrà fer la tramitació
                  $req -> content = "Existeix una petició amb el mateix nom introduït seleccionat. <br>
                       seleccioneu un altre nom diferent al generar la petició";
                  } else {
                       $accents = $db->query("SET NAMES 'utf8'");
                       $query = "insert into peticions_csr values
                          (null,'".$resum."','".$data_acual."','".$contrasenyaX."','".$usuari.
                              "','".$org."','".$dept."','".$correu."','".$pais."','".$prov."','".$loc."',0,'".$pkcs10."','".$pkey."')";

                       $result = $db->query($query);
                       if ($result) {
                              $req -> content ="La petició  ha estat formulada i pendent de tramitació".
                                  "<br>".$data_acual."<br>";
                       }

                  }
            }
              mysqli_close();

          } else  {
              $req -> content ="El secret enviat no es correspon amb l'introduït";
          }
  } else {
        $req -> content = "Error d'autenticació";
  }
  //Aquí el display
  $req ->Display();
  ?>