<?php
 /**
 *
 * S'inicia una sessió d'administrador que requerirà la autenticació del mateix.
 *
 * @author Eugeni Queralt
 * @package tfcUOC
*/
  require_once ('page.php');
  session_start(); //control de la sessió de l'administrador
  /**
   * Extensió de la pàgina principal que mostra les funcions administratives de la CA
   * @package tfcUOC
   */
  class AdminPage extends Page
  {
    /**
     * Aquí es desa la contrasenya xifrada de l'administrador
     * @access private
     */
    private $passsha1="7c4a8d09ca3762af61e59520943dc26494f8941b";
    /**
     * Contrasenya d'administrador xifrada
     *
     * Funció accessora per la contrasenya de l'administrador
     * @return string contrasenya de l'administrador xifrada
     */
    public function getPassCA()
    {
        return $this->passsha1;
    }

    /**
     * Segona fila de botons per l'administrador
     *
     * @var array de botons amb enllaços als diferents serveis administratius
     * @access private
     */

    private $row2buttons = array( 
                              		'Signar peticions' 	=> '/tfc/admin/signar.php',
                             		'Revocar certificats' 	=> '/tfc/admin/revocar.php',
                              		'Renovar certificat'	=> '/tfc/admin/renovar.php',
                              		'Generar revocats'	=> '/tfc/admin/genRevocats.php',
                                        'Sortir'            	=> '/tfc/admin/sortir.php'
                            );
    /**
     * Display de les funcions administratives
     *
     * Funció que mostra els diferents elements de la pàgina d'administració
     * Sobrecarrega el mètode de la superclasse Page.
     */
    public function Display()
    {
      //echo "<html>\n<head>\n";
      $this -> DisplayCapcalera();
      $this -> DisplayTitle();
      $this -> DisplayKeywords();
      $this -> DisplayStyles();
      echo "</head>\n<body>\n";
      $this -> DisplayHeader();
      $this -> DisplayMenu($this->buttons);
      $this -> DisplayMenu($this->row2buttons);
      echo $this->content;//potser caldria fer-ho amb un mètode d'accés 
      $this -> DisplayFooter();
      echo "</body>\n</html>\n";
    }
  }

  //Cal autenticar-se per accedir a aquesta secció

  $admin = new AdminPage();
  if (!isset ($_SESSION['administrador'])&& !isset($_POST['autenticar'])){
      $admin -> content =" <form method='post' action=''>
        <fieldset>
        <legend>Cal autenticar-se com administrador</legend>
        <p>
            Contrasenya de l'administrador
        </p>
        <table>
            <colgroup><col width='180px'></colgroup>
                <tr><th>Contrasenya_Adm</th><td><input type='password' name='passwd' size='15' maxlength='14'></td></tr>
        </table>

        <table>
                <tr><td ><input type='submit' name='autenticar' value='Autenticar'></td></tr>
        </table>
        </fieldset>
    </form>";

  } else {
      $admin -> content = "Autenticació exitosa";
  }
     
    $pasCA = $admin->getPassCA();
    $pwdCA = $admin->Neteja($_POST['passwd']);

  if (isset($_POST['autenticar'])&&!isset ($_SESSION['administrador'])) {
      if (sha1($pwdCA) == $pasCA ){
          //Registrem la variable de sessió amb el 
             $_SESSION['administrador'] = md5("admin".$admin->getPassCA());
       } else 
          {
             $admin -> content = "Error d'autenticació";
          }
  }

  $admin -> Display();
?>
