<?php
/**
  * Genera la llista de revocació.
  *
  * Cal estar autenticat com a administrador.
  *
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */

 require_once ('../page.php');
 session_start();
/**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class GenrvPage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)
 
  }
  // Primer cal estar autenticat per accedir a aquesta zona
  // 

    $genrev = new GenrvPage();

    //Verificarem que l'administrador estigui autenticat
    if (isset($_SESSION['administrador'])) {
       // $genrev -> content = "Estàs autenticat com administrador"."<br>".
       //       "Variable de sessió establerta.";
        	$pwdCA="123456"; //Compte amb deixar-la aquí exposada, demanar-la i xifrar-la.

                //Genera la llista de certificats revocats
                exec("sudo openssl ca -gencrl -out /etc/ssl/crl/revocats.crl -config /etc/ssl/openssl.cnf -passin pass:$pwdCA 2>&1", $revs,$retorna);
                if (!$retorna){
                    $genrev -> content = "<br><b>La llista de certificats revocats s'ha generat correctament</b><br>";
                } else {
                    $genrev -> content = "<br><b>Ha fallat la generació de la llista de certificats revocats</b><br><br>";
                }
                unset($revs);
                $crl=file_get_contents('/etc/ssl/crl/revocats.crl');
                $genrev -> content .=
                    "<fieldset>
                    <legend>Llista de revocació</legend>
                    <p>
                        Arxiu CRL.
                    </p>
                    <table>
                        <colgroup><col width='180px'></colgroup>
                            <tr><td><textarea rows='15' cols='70' name='crl'>$crl</textarea></td></tr>
                    </table>
                    </fieldset>";

    } else {
        $genrev -> content = "Error d'autenticació";
    }
    
    $genrev ->Display();
?>
