<?php
/**
  * Accés a la llista de revocació
  *
  * Permet accedir als usuaris degudament autenticats  a la descàrrega de la llista de revocació de certificats
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */
    require_once ("../page.php");
    session_start(); //control de la sessió de l'usuari
  /**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class LlistaReqPage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)
   
  }
   $llrev = new LlistaReqPage();
   if (isset($_SESSION['usuari'])) {
     //Mostra la llista de certificats revocats
        exec("/usr/bin/openssl crl -in /etc/ssl/crl/revocats.crl -out /tmp/revocats.crl 2>&1", $revs);
        unset($revs);

        /*exec("/usr/bin/openssl crl -in /etc/ssl/crl/revocats.crl -text 2>&1", $revs);
        $sortida=implode("<br>",$revs);
        unset($revs);
         */
        //Connectem amb la BD
         $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
         if (mysqli_connect_errno ()){
             die("Error de connexió amb la Base de Dades".
                  mysqli_connect_errno ());
            }
        //Selecionem els revocats de la BD
        $query = "select * from certificats_clients where revocat = 1";
        $results = $db->query($query);
        $llistarev="";
        While ($row = $results->fetch_array(MYSQLI_BOTH)){
                        $llistarev .= "<tr>".
                        "<td>".$row['commonName']."</td>".
                        "<td>".$row['organizationName']."</td>".
                        "<td>".$row['emailAddress']."</td>".
                        "</tr>";
                    }
        $crl=file_get_contents('/etc/ssl/crl/revocats.crl');
        $llrev -> content =
                    "<fieldset>
                    <legend>Llista de revocació</legend>
                    <p>
                        Certificats revocats.
                    </p>
                    <table>
                        <colgroup><col width='180px'></colgroup>
                        $llistarev
                    </table>
                    <p>
                        Arxiu CRL.
                    </p>
                    <table>
                        <colgroup><col width='180px'></colgroup>
                            <tr>
                                <td><textarea rows='15' cols='70' name='crl'>$crl</textarea></td>
                                <td><a href='../serveis/descarregar.php?f=revocats.crl'><img src = '/tfc/imatges/down.jpeg'></a></td>
                            </tr>
                    </table>
                    </fieldset>";
        //Tanquem BD
        mysqli_close();
         
    } else {
        $llrev -> content = "Error d'autenticació";
     }

    //Aquí el display
    $llrev ->Display();
?>