<?php
/**
  * Descàrregues de certificats
  *
  * Permet descarregar el 4 arxius de l'array $arxius. Cal estar autenticat per accedir
  * a les descàrregues i ens assegurem que només es descarreguem els arxius indicats, si
  * s'intenta descarregar qualsevol atra arxiu o incloure rutes a altres documents,
  * es sortirà del sistema amb el missatge d'error corresponent
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */
    session_start(); //control de la sessió de l'usuari
    if (isset($_SESSION['usuari'])) {
            $arxius = array("cert.p12", "cert.pem", "key.pem", "revocats.crl");
            $f = $_GET["f"];
            if(strpos($f,"/")!==false){
                die("<b>ERROR!</b> No es pot navegar per altres directoris.");
            }
            if(!in_array($f,$arxius)){
                die("<b>ERROR!</b> No es possible descarregar $f");
            }
            $f ="/tmp/".$f; // Els arxius estan al directori temporal
            header("Content-type: application/octet-stream");
            header("Content-Disposition: attachment; filename=\"$f\"\n");
            $fp=fopen("$f", "r");
            fpassthru($fp);
   } else {
        die ("Error d'autenticació");
   }
?>
