<?php
/**
  * Registre d'usuaris nous
  *
  * La pàgina permet el registre de nous usuaris al sitema per poder accedir als serveis de la CA
  *
  * @author Eugeni Queralt
  * @package tfcUOC
  */
require_once ('../page.php');
session_start(); //control de la sessió de l'usuari
  /**
   * Extensió de la superclasse Page per manteniment de l'entorn de la CA
   * @package tfcUOC
   */
  class RegistrePage extends Page
  {
    //Atributs i/o mètodes que es considerin (netejar entrades d'usuaris etc...)
   
  }
   $regis = new RegistrePage();
   if (!isset($_SESSION['usuari'])) {
   $regis -> content = " 
        <form method='post' action='registre.php'>
            <fieldset>
            <legend>Registre de nous usuaris</legend>
            <table>
                <colgroup><col width='180px'></colgroup>
                    <tr><th>Nom Complert: </th><td><input type='text' name='usuari' size='30' maxlength='30'></td></tr>
                    <tr><th>Email: </th><td><input type='email' name='correu' size='30' maxlength='30'></td></tr>
                    <tr><th>Usuari: </th><td><input type='text' name='nick' size='30' maxlength='15'></td></tr>
                    <tr><th>Contrasenya: </th><td><input type='password' name='passwd' size='30' maxlength='15'></td></tr>
            </table>

            <table>
                    <tr><td ><input type='submit' name='registrar' value='Registre'></td></tr>
            </table>
            </fieldset>
        </form>";
        //Recollim les dades
        if (isset ($_POST['registrar'])){
            $nom   = $regis->Neteja($_POST['usuari']);
            $email = $regis->Neteja($_POST['correu']);
            $nick  = $regis->Neteja($_POST['nick']);
            $pass  = $regis->Neteja($_POST['passwd']); //passwd
            $passX  = sha1($pass); //xifrem passwd
            //Connectem amb la BD
            $db = new mysqli('localhost', 'keni','bdpass', 'tfcCA');
            if (mysqli_connect_errno ()){
               $regis-> content ="Error de connexió amb la Base de Dades".
                    mysqli_connect_errno ();
            } else
                if ($nom == "" || $email == "" || $nick == "" || $pass == ""){
                    $regis -> content = "Cal omplir totes les dades del formulari";
                } else
                    if (!$regis->ValidaMail($email)){
                    $regis -> content = "La adreça de correu ha de tenir un format correcte.";
                } else {
                    //Comprovem si exiteix l'usuari (nick)
                    $query = " select * from usuaris where user='$nick' ";
                    $results = $db->query($query);
                    if (mysqli_fetch_array($results)) {
                        $regis -> content = "El sobrenom de l'usuari ja està present a la BD.";
                    } else {
                        //Comprovem si el correu està tmb registrat
                        $query = " select * from usuaris where email='$email' ";
                        $results = $db->query($query);
                        if (mysqli_fetch_array($results)) {
                            $regis -> content = "El correu electrònic ja està present a la BD.";
                        } else {
                            //Registrem a l'usuari i iniciem la sessió d'usuari
                            $query = "insert into usuaris values
                                  (null,'".$nom."','".$nick."','".$email."','".$passX."')";
                            $results = $db->query($query);
                                  $_SESSION['usuari'] = $nick;
                                  $regis -> content = "Ja estàs autenticat com usuari registrat";
                        }

                    }
                }
                //Tanquem la BD
                mysqli_close();
            }
        
     } else {
        $regis -> content = "Ja estàs autenticat com usuari registrat";
     }
    //Aquí el display
    $regis ->Display();
?>